def readRecord(line):
    ans = {}
    line = line.split(',')
    ans['LongName'] = line[0]
    ans['ID'] = line[1].strip()
    ans['Length'] = float(line[2])
    ans['Prereqs'] = [x.strip() for x in line[3:]]
    return ans

ifile = open('pred_data.csv')

# Read the data
# Skip the header
ifile.readline()

# Read the records
recs = {}
for line in ifile:
    rec = readRecord(line)
    recs[rec['ID']] = rec

# Output the nodes set
nodesset = ['Start','End'] + recs.keys()
ofile = open('gams_nodesSet.csv','w')
for node in nodesset:
    print >> ofile, node
ofile.close()

# Output the nodes data We don't really need to do this, it is just so that we
# can have the long names when we do the report at the end.

ofile = open('gams_acronyms.csv','w')
for r in recs.itervalues():
    print >> ofile, r['LongName']
ofile.close()

ofile = open('gams_nodesData.csv','w')
print >> ofile, 'Node,LongName,Length'
for r in recs.itervalues():
    print >> ofile, "%s,%s,%f"%(r['ID'],r['LongName'],r['Length'])
ofile.close()

# Now output the arc set and the arcs data
arcs = {}
for i in recs.itervalues():
    for j in i['Prereqs']:
        arcs[ (j, i['ID']) ] = recs[j]['Length']
for n in nodesset:
    if n == 'Start':
        continue
    arcs[('Start',n)] = 0
for n in nodesset:
    if n == 'End':
        continue
    elif n == 'Start':
        arcs[(n,'End')] = 0
    else:
        arcs[(n,'End')] = recs[n]['Length']

ofile = open('gams_arcsSet.csv','w')
for i,j in arcs:
    print >> ofile, '%s,%s'%(i,j)
ofile.close()

ofile = open('gams_arcsData.csv','w')
print >> ofile, 'StartNode,EndNode,Cost'
for i,j in arcs:
    print >> ofile, '%s,%s,%f'%(i,j,-arcs[(i,j)])
ofile.close()




